﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace ExpandChild
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        private ObservableCollection<TreeData> _data;
        public MainWindow()
        {
            _data = new ObservableCollection<TreeData>();
            InitializeComponent();
            _data = TreeData.GenerateTreeData();
            treeGrid.DataContext = _data;
        }

        private void treeGrid_Loaded(object sender, RoutedEventArgs e)
        {
           // this.treeGrid.Records.ExpandAll(true);
        }

        private void treeGrid_KeyDown(object sender, KeyEventArgs e)
        {
            var recordIndex = treeGrid.ActiveRecord.Index;

            if (e.Key == Key.Insert)
            {
                TreeData n = new TreeData
                {
                    Children = new ObservableCollection<TreeData>()
                };
              
            
                _data.Insert(recordIndex + 1,n);
            }

            if (e.Key == Key.RightShift )
            {
                TreeData n1 = new TreeData
                {
                    Children = new ObservableCollection<TreeData>()
                };

                for (int p = 0; p < 1; p++)
                {
                    n1.Children.Add(new TreeData
                    {

                    });
                }
                _data[recordIndex].Children.Insert(0, n1);
               
                   
            }
        }
    }

    
    public class TreeData : PropertyChangedNotifier
    {

        public TreeData()
        {
        }

        private int? id;

        public int? ID
        {
            get { return id; }
            set { id = value; OnPropertyChagned("ID"); }
        }

        private string name;

        public string Name
        {
            get { return name; }
            set { name = value; OnPropertyChagned("Name"); }
        }

        private ObservableCollection<TreeData> children;

        public ObservableCollection<TreeData> Children
        {
            get { return children; }
            set
            {
                children = value;
                OnPropertyChagned("Children");
            }
        }

        public static ObservableCollection<TreeData> GenerateTreeData()
        {
            ObservableCollection<TreeData> data = new ObservableCollection<TreeData>();
            for (int i = 0; i < 10; i++)
            {
                TreeData n = new TreeData
                {
                    ID = i,
                    Name = "Row " + i,
                    Children = new ObservableCollection<TreeData>()
                };

                for (int j = 0; j < 5; j++)
                {
                    TreeData n1 = new TreeData
                    {
                        ID = i + j,
                        Name = "Row " + i + " " + j,
                        Children = new ObservableCollection<TreeData>()
                    };

                    for (int p = 0; p < 5; p++)
                    {
                        n1.Children.Add(new TreeData
                        {
                            ID = i + j + p,
                            Name = "Child " + i + " " + j + " " + p,
                        });
                    }

                    n.Children.Add(n1);
                }

                data.Add(n);
            }

            return data;
        }
    }

    public class PropertyChangedNotifier : INotifyPropertyChanged
    {
        public event PropertyChangedEventHandler PropertyChanged;

        public void OnPropertyChagned(string name)
        {
            if (PropertyChanged != null)
                PropertyChanged(this, new PropertyChangedEventArgs(name));
        }
    }	

}
